/************************************************************************
 *									*
 *		qr|QRQbCu				*
 *									*
 *				: qr|QRQb@S`l		*
 *		t@C	: rs.c					*
 *		쐬		: s.aizawa				*
 *									*
 ************************************************************************/

#include	<stddef.h>
#include	<stdlib.h>
#include	<dos.h>
#include	<conio.h>
#include	"rs232c.h"

#pragma	check_stack-		/* X^bN`FbN */

/*=======================================================================
 |
 |		qr|QRQbI[v
 |
 |	int	rsx_open(channel, rsprm)
 |
 |		int	channel;	`lԍiP`Rj
 |		RSPRM	*rsprm;		qr|QRQbI[vp[^
 |
 |		Ԓl			OFI[v
 |					PFI[vς
 |					QF[hp[^G[
 |					RFd[hp[^G[
 |					SF{[[gp[^G[
 |					TFpeB[p[^G[
 |					UFLN^p[^G[
 |					VFXgbvrbgp[^G[
 |					WFt[p[^G[
 |					XFcsqp[^G[
 |					10FMobt@mێs
 |
 =======================================================================*/
int	rsx_open(int channel, RSPRM *rsprm)
{
	static	int	(*rs_func[3])(RSPRM *) = {
		rs1_open, rs2_open, rs3_open
	};

	return (*rs_func[channel])(rsprm);
}

/*=======================================================================
 |
 |		qr|QRQbăI[v
 |
 |	int	rsx_reopen(channel, rsprm)
 |
 |		int	channel;	`lԍiP`Rj
 |		RSPRM	*rsprm;		qr|QRQbI[vp[^
 |
 |		Ԓl			OFI[v
 |					PFI[v
 |					QF[hp[^G[
 |					RFd[hp[^G[
 |					SF{[[gp[^G[
 |					TFpeB[p[^G[
 |					UFLN^p[^G[
 |					VFXgbvrbgp[^G[
 |					WFt[p[^G[
 |
 =======================================================================*/
int	rsx_reopen(int channel, RSPRM *rsprm)
{
	static	int	(*rs_func[3])(RSPRM *) = {
		rs1_reopen, rs2_reopen, rs3_reopen
	};

	return (*rs_func[channel])(rsprm);
}

/*=======================================================================
 |
 |		qr|QRQbN[Y
 |
 |	void	rsx_close(channel)
 |
 |		int	channel;	`lԍiP`Rj
 |
 =======================================================================*/
void	rsx_close(int channel)
{
	static	void	(*rs_func[3])(void) = {
		rs1_close, rs2_close, rs3_close
	};

	(*rs_func[channel])();
}

/*=======================================================================
 |
 |		Mobt@`FbN
 |
 |	int	rsx_rxc(channel)
 |
 |		int	channel;	`lԍiP`Rj
 |
 |		Ԓl			M
 |
 =======================================================================*/
int	rsx_rxc(int channel)
{
	static	int	(*rs_func[3])(void) = {
		rs1_rxc, rs2_rxc, rs3_rxc
	};

	return (*rs_func[channel])();
}

/*=======================================================================
 |
 |		PM
 |
 |	int	rsx_get(channel)
 |
 |		int	channel;	`lԍiP`Rj
 |
 |		Ԓl			M
 |
 =======================================================================*/
int	rsx_get(int channel)
{
	static	int	(*rs_func[3])(void) = {
		rs1_get, rs2_get, rs3_get
	};

	return (*rs_func[channel])();
}

/*=======================================================================
 |
 |		Mobt@NA
 |
 |	void	rsx_clear(channel)
 |
 |		int	channel;	`lԍiP`Rj
 |
 =======================================================================*/
void	rsx_clear(int channel)
{
	static	void	(*rs_func[3])(void) = {
		rs1_clear, rs2_clear, rs3_clear
	};

	(*rs_func[channel])();
}

/*=======================================================================
 |
 |		PM
 |
 |	void	rsx_put(channel, c)
 |
 |		int	channel;	`lԍiP`Rj
 |		int	c;		M
 |
 =======================================================================*/
void	rsx_put(int channel, int c)
{
	static	void	(*rs_func[3])(int) = {
		rs1_put, rs2_put, rs3_put
	};

	(*rs_func[channel])(c);
}

/*=======================================================================
 |
 |		ubNM
 |
 |	void	rsx_send(channel, s, len)
 |
 |		int	channel;	`lԍiP`Rj
 |		char	*s;		M
 |		int	len;		
 |
 =======================================================================*/
void	rsx_send(int channel, char *s, int len)
{
	static	void	(*rs_func[3])(char *, int) = {
		rs1_send, rs2_send, rs3_send
	};

	(*rs_func[channel])(s, len);
}

/*=======================================================================
 |
 |		ubNMv
 |
 |	int	rsx_sendreq(channel, s, len)
 |
 |		int	channel;	`lԍiP`Rj
 |		char	*s;		M
 |		int	len;		
 |
 |		Ԓl			OF@PFMobt@mێs
 |
 =======================================================================*/
int	rsx_sendreq(int channel, char *s, int len)
{
	static	int	(*rs_func[3])(char *, int) = {
		rs1_sendreq, rs2_sendreq, rs3_sendreq
	};

	return (*rs_func[channel])(s, len);
}

/*=======================================================================
 |
 |		f[^M҂
 |
 |	void	rsx_swait(channel)
 |
 |		int	channel;	`lԍiP`Rj
 |
 =======================================================================*/
void	rsx_swait(int channel)
{
	static	void	(*rs_func[3])(void) = {
		rs1_swait, rs2_swait, rs3_swait
	};

	(*rs_func[channel])();
}

/*=======================================================================
 |
 |		t[ݒ
 |
 |	void	rsx_flow(channel, ctrl)
 |
 |		int	channel;	`lԍiP`Rj
 |		int	ctrl;		t[
 |
 =======================================================================*/
void	rsx_flow(int channel, int ctrl)
{
	static	void	(*rs_func[3])(int) = {
		rs1_flow, rs2_flow, rs3_flow
	};

	(*rs_func[channel])(ctrl);
}

/*=======================================================================
 |
 |		o`cݒ
 |
 |	void	rsx_pad(channel, lpad, lpadsize, tpad, tpadsize)
 |
 |		int	channel;	`lԍiP`Rj
 |		char	*lpad;		[fBOpbhf[^
 |		int	lpad_size;	[fBOpbhf[^
 |		char	*tpad;		g[Opbhf[^
 |		int	tpadsize;	g[Opbhf[^
 |
 =======================================================================*/
void	rsx_pad(int channel, char *lpad, int lpadsize, char *tpad, int tpadsize)
{
	static	void	(*rs_func[3])(char *, int, char *, int) = {
		rs1_pad, rs2_pad, rs3_pad
	};

	(*rs_func[channel])(lpad, lpadsize, tpad, tpadsize);
}

/*=======================================================================
 |
 |		M荞ݏݒ
 |
 |	void	rsx_rcvint(channel, func)
 |
 |		int	channel;	`lԍiP`Rj
 |		int	(*func)();	M荞ݏ
 |
 =======================================================================*/
void	rsx_rcvint(int channel, int (*func)(int))
{
	static	void	(*rs_func[3])(int (*func)(int)) = {
		rs1_rcvint, rs2_rcvint, rs3_rcvint
	};

	(*rs_func[channel])(func);
}

/*=======================================================================
 |
 |		G^[ng[hZbg
 |
 |	void	rsx_ehm(channel)
 |
 |		int	channel;	`lԍiP`Rj
 |
 =======================================================================*/
void	rsx_ehm(int channel)
{
	static	void	(*rs_func[3])(void) = {
		rs1_ehm, rs2_ehm, rs3_ehm
	};

	(*rs_func[channel])();
}

/*=======================================================================
 |
 |		crq`FbN
 |
 |	int	rsx_dsr(channel)
 |
 |		int	channel;	`lԍiP`Rj
 |
 |		Ԓl		OFcrqIt@PFcrqI
 |
 =======================================================================*/
int	rsx_dsr(int channel)
{
	static	int	(*rs_func[3])(void) = {
		rs1_dsr, rs2_dsr, rs3_dsr
	};

	return (*rs_func[channel])();
}

/*=======================================================================
 |
 |		LA`FbN
 |
 |	int	rsx_cd(channel)
 |
 |		int	channel;	`lԍiP`Rj
 |
 |		Ԓl		OFLAIt@PFLAI
 |
 =======================================================================*/
int	rsx_cd(int channel)
{
	static	int	(*rs_func[3])(void) = {
		rs1_cd, rs2_cd, rs3_cd
	};

	return (*rs_func[channel])();
}

/*=======================================================================
 |
 |		bsr`FbN
 |
 |	int	rsx_cts(channel)
 |
 |		int	channel;	`lԍiP`Rj
 |
 |		Ԓl		OFbsrIt@PFbsrI
 |
 =======================================================================*/
int	rsx_cts(int channel)
{
	static	int	(*rs_func[3])(void) = {
		rs1_cts, rs2_cts, rs3_cts
	};

	return (*rs_func[channel])();
}

/*=======================================================================
 |
 |		bh`FbN
 |
 |	int	rsx_ci(channel)
 |
 |		int	channel;	`lԍiP`Rj
 |
 |		Ԓl		OFbhIt@PFbhI
 |
 =======================================================================*/
int	rsx_ci(int channel)
{
	static	int	(*rs_func[3])(void) = {
		rs1_ci, rs2_ci, rs3_ci
	};

	return (*rs_func[channel])();
}

/*=======================================================================
 |
 |		csq
 |
 |	void	rsx_dtr(channel, sw);
 |
 |		int	channel;	`lԍiP`Rj
 |		int	sw;		OFcsqIt@OFcsqI
 |
 =======================================================================*/
void	rsx_dtr(int channel, int sw)
{
	static	void	(*rs_func[3])(int) = {
		rs1_dtr, rs2_dtr, rs3_dtr
	};

	(*rs_func[channel])(sw);
}

/*=======================================================================
 |
 |		qsr
 |
 |	void	rsx_rts(channel, sw);
 |
 |		int	channel;	`lԍiP`Rj
 |		int	sw;		OFqsrIt@OFqsrI
 |
 =======================================================================*/
void	rsx_rts(int channel, int sw)
{
	static	void	(*rs_func[3])(int) = {
		rs1_rts, rs2_rts, rs3_rts
	};

	(*rs_func[channel])(sw);
}

/*=======================================================================
 |
 |		u[NMo
 |
 |	void	rsx_break(channel, sw);
 |
 |		int	channel;	`lԍiP`Rj
 |		int	sw;		  OFu[NMIt
 |					OFu[NMI
 |
 =======================================================================*/
void	rsx_break(int channel, int sw)
{
	static	void	(*rs_func[3])(int) = {
		rs1_break, rs2_break, rs3_break
	};

	(*rs_func[channel])(sw);
}

/*=======================================================================
 |
 |		R}ho
 |
 |	void	rsx_cmd(channel, cmd, mask)
 |
 |		int	channel;	`lԍiP`Rj
 |		int	cmd;		R}h
 |		int	mask;		}XNf[^
 |
 =======================================================================*/
void	rsx_cmd(int channel, int cmd, int mask)
{
	static	void	(*rs_func[3])(int, int) = {
		rs1_cmd, rs2_cmd, rs3_cmd
	};

	(*rs_func[channel])(cmd, mask);
}

/*=======================================================================
 |
 |		Xe[^Xǂݍ
 |
 |	int	rsx_sts(channel)
 |
 |		int	channel;	`lԍiP`Rj
 |
 |		Ԓl			Xe[^X
 |
 =======================================================================*/
int	rsx_sts(int channel)
{
	static	int	(*rs_func[3])(void) = {
		rs1_sts, rs2_sts, rs3_sts
	};

	return (*rs_func[channel])();
}
